cdac.medinfo.sdk.hl7282.baselibs

## Class OSP

- java.lang.Object
- - cdac.medinfo.sdk.hl7282.baselibs.CompositeDataType
  - - cdac.medinfo.sdk.hl7282.baselibs.OSP

- All Implemented Interfaces:
    IDataType

      public class OSP
      extends CompositeDataType

  OSP - Occurrence span code and date

  This data type defines A code and the related dates that identify an event that relates to the payment of the claim. For example, Prior Stay Dates which is the from/through dates given by the patient of any hospital stay that ended within 60 days of this hospital or SNF admission.

  Represents an HL7 PIP data type. This data type has the following attributes:

  1. Occurrence Span Code (CNE)Required
  2. Occurrence Span Start Date (DT)Conditional
  3. Occurrence Span Stop Date (DT)Conditional

  This class provides accessors & mutators for the elements mentioned above. This class override the equal method, to check whether some other object is "equal to" this one.

  User can also create Data Type through `DataElementFactory`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `OSP()` Default Constructor for OSP
    `OSP(int iComponentType, IDataTypeMap objIDataTypeMap)` Constructor for OSP class which takes two arguments and sets the value in the respective member variable.
    `OSP(int iComponentType, int iMinLength, int iMaxLength, java.lang.String strCLength, IDataTypeMap objIDataTypeMap)` Constructor for OSP class which takes five arguments and sets the value in the respective member variable.
    `OSP(int iComponentType, int iMinLength, int iMaxLength, java.lang.String strCLength, int ITableNo, IDataTypeMap objIDataTypeMap)` Constructor for OSP class which takes six arguments and sets the value in the respective member variable.
    `OSP(int iMinLength, int iMaxLength, java.lang.String strCLength, int iComponentType)` Constructor for OSP class which takes four arguments and sets the value in the respective member variable.
    `OSP(int iMinLength, int iMaxLength, java.lang.String strCLength, int iTableNo, int iComponentType)` Constructor for OSP class which takes five arguments and sets the value in the respective member variable.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(java.lang.Object objObject)` This method checks the equality of Object.
    `CNE` | `getOccurrenceSpanCode()` Returns Occurrence Span Code
    `DT` | `getOccurrenceSpanStartDate()` Returns Occurrence Span Start Date
    `DT` | `getOccurrenceSpanStopDate()` Returns Occurrence Span Stop Date
    `void` | `setOccurrenceSpanCode(CNE objOccurrenceSpanCode)` Sets the OccurrenceSpanCode.
    `void` | `setOccurrenceSpanStartDate(DT objDT)` Sets the OccurrenceSpanStartDate.
    `void` | `setOccurrenceSpanStartDate(java.lang.String strOccurrenceSpanStartDate)` Sets the OccurrenceSpanStartDate.
    `void` | `setOccurrenceSpanStopDate(DT objDT)` Sets the OccurrenceSpanStopDate.
    `void` | `setOccurrenceSpanStopDate(java.lang.String strOccurrenceSpanStopDate)` Sets the OccurrenceSpanStopDate.
    `boolean` | `validate()` The Method validates the Input value,and if validated properly then returns true.

    - ### Methods inherited from class cdac.medinfo.sdk.hl7282.baselibs.CompositeDataType

      `copy, dumpDataType, getAttributes, getDataTypeName, getLength, getValue, isPrimitive, read, setValue, write, writeToXML`

    - ### Methods inherited from class java.lang.Object

      `getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### OSP

          public OSP()

      Default Constructor for OSP

    - #### OSP

          public OSP(int iMinLength,
             int iMaxLength,
             java.lang.String strCLength,
             int iComponentType)
              throws InvalidComponentTypeException

      Constructor for OSP class which takes four arguments and sets the value in the respective member variable.
      Parameters:
        `iMinLength` - The Minimum length the DataType can have.
        `iMaxLength` - The Maximum length the DataType can have.
        `iCLength` - The Conformance length the DataType can have.
        `iComponentType` - The Type of the component i.e Component or a subcomponent.
      Throws:
        `InvalidComponentTypeException` - - if Component Type is not specified or valid.

    - #### OSP

          public OSP(int iMinLength,
             int iMaxLength,
             java.lang.String strCLength,
             int iTableNo,
             int iComponentType)
              throws InvalidComponentTypeException

      Constructor for OSP class which takes five arguments and sets the value in the respective member variable.
      Parameters:
        `iMinLength` - The Minimum length the DataType can have.
        `iMaxLength` - The Maximum length the DataType can have.
        `iCLength` - The Conformance length the DataType can have.
        `iTableNo` - The Table number to which the value for the component is specified.
        `iComponentType` - The Type of the component i.e Component or a subcomponent.
      Throws:
        `InvalidComponentTypeException` - - if Component Type is not specified or valid.

    - #### OSP

          public OSP(int iComponentType,
             IDataTypeMap objIDataTypeMap)

      Constructor for OSP class which takes two arguments and sets the value in the respective member variable.
      Parameters:
        `objIDataTypeMap` - object of Data Type Map.
        `iComponentType` - The Type of the component i.e Component or a subcomponent.
      Throws:
        `InvalidComponentTypeException` - - if Component Type is not specified or valid.

    - #### OSP

          public OSP(int iComponentType,
             int iMinLength,
             int iMaxLength,
             java.lang.String strCLength,
             IDataTypeMap objIDataTypeMap)

      Constructor for OSP class which takes five arguments and sets the value in the respective member variable.
      Parameters:
        `objIDataTypeMap` - object of Data Type Map.
        `iComponentType` - The Type of the component i.e Component or a subcomponent.
        `iMinLength` - The Minimum length the DataType can have.
        `iMaxLength` - The Maximum length the DataType can have.
        `iCLength` - The Conformance length the DataType can have.
      Throws:
        `InvalidComponentTypeException` - - if Component Type is not specified or valid.

    - #### OSP

          public OSP(int iComponentType,
             int iMinLength,
             int iMaxLength,
             java.lang.String strCLength,
             int ITableNo,
             IDataTypeMap objIDataTypeMap)

      Constructor for OSP class which takes six arguments and sets the value in the respective member variable.
      Parameters:
        `objIDataTypeMap` - object of Data Type Map.
        `iComponentType` - The Type of the component i.e Component or a subcomponent.
        `iMinLength` - The Minimum length the DataType can have.
        `iMaxLength` - The Maximum length the DataType can have.
        `iCLength` - The Conformance length the DataType can have.
        `iTableNo` - The Table number to which the value for the component is specified.
      Throws:
        `InvalidComponentTypeException` - - if Component Type is not specified or valid.

  - ### Method Detail

    - #### setOccurrenceSpanCode

          public void setOccurrenceSpanCode(CNE objOccurrenceSpanCode)

      Sets the OccurrenceSpanCode.
      Parameters:
        `objOccurrenceSpanCode` - Specifies the NUBC code itself that identifies an event that relates to the payment of a claim.

    - #### setOccurrenceSpanStartDate

          public void setOccurrenceSpanStartDate(java.lang.String strOccurrenceSpanStartDate)

      Sets the OccurrenceSpanStartDate.
      Parameters:
        `strOccurrenceSpanStartDate` - Specifies date an event started that relates to the payment of a claim.

    - #### setOccurrenceSpanStartDate

          public void setOccurrenceSpanStartDate(DT objDT)

      Sets the OccurrenceSpanStartDate.
      Parameters:
        `objDT` - Specifies date an event started that relates to the payment of a claim.

    - #### setOccurrenceSpanStopDate

          public void setOccurrenceSpanStopDate(java.lang.String strOccurrenceSpanStopDate)

      Sets the OccurrenceSpanStopDate.
      Parameters:
        `strOccurrenceSpanStopDate` - Specifies date an event ended that relates to the payment of a claim.

    - #### setOccurrenceSpanStopDate

          public void setOccurrenceSpanStopDate(DT objDT)

      Sets the OccurrenceSpanStopDate.
      Parameters:
        `objDT` - Specifies date an event ended that relates to the payment of a claim.

    - #### getOccurrenceSpanCode

          public CNE getOccurrenceSpanCode()

      Returns Occurrence Span Code
      Returns:
        CNE - data type.

    - #### getOccurrenceSpanStartDate

          public DT getOccurrenceSpanStartDate()

      Returns Occurrence Span Start Date
      Returns:
        DT - data type.

    - #### getOccurrenceSpanStopDate

          public DT getOccurrenceSpanStopDate()

      Returns Occurrence Span Stop Date
      Returns:
        DT - data type.

    - #### validate

          public boolean validate()
                           throws InvalidDataTypeException

      The Method validates the Input value,and if validated properly then returns true. Here the validetion is based on the compulsory fields for the Datatype.
      Specified by:
        `validate` in interface `IDataType`
      Overrides:
        `validate` in class `CompositeDataType`
      Returns:
        boolean - true or false.
      Throws:
        `InvalidDataTypeException` - - if Invalid values is entered or Mandatory field is missing.

    - #### equals

          public boolean equals(java.lang.Object objObject)

      This method checks the equality of Object.
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `objObject` - object of Object class.
      Returns:
        boolean - shows success or failure of the comparison.